/***************************************************************************
                          x11.cpp
                          -------
    begin                : Wed Feb 26 2003
    copyright            : (C) 2003 by kiriuja
    email                : kplayer-dev@en-directo.net
 ***************************************************************************/

/***************************************************************************
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#include <X11/Xlib.h>
#include <kdebug.h>

/*bool KPlayerX11TestGrab (Display* display, int winid)
{
  if ( int status = XGrabPointer (display, winid, False,
        (uint)(ButtonPressMask | ButtonReleaseMask | PointerMotionMask | EnterWindowMask | LeaveWindowMask),
        GrabModeAsync, GrabModeAsync, None, None, CurrentTime) )
  {
    const char *s =
      status == GrabNotViewable ? "GrabNotViewable" :
      status == AlreadyGrabbed  ? "AlreadyGrabbed" :
      status == GrabFrozen      ? "GrabFrozen" :
      status == GrabInvalidTime ? "GrabInvalidTime" : "Unknown";
    kdDebug() << "Grab failed, status: " << s << "\n";
    return false;
  }
  kdDebug() << "Grab succeeded\n";
  XUngrabPointer (display, CurrentTime);
  return true;
}*/

extern void KPlayerWidgetResizeHandler (bool);

typedef int (*QX11EventFilter) (XEvent*);

static QX11EventFilter PreviousX11EventFilter = 0;

int KPlayerX11EventFilter (XEvent* event)
{
//kdDebug() << "X11 event type " << event -> type << "\n";
  if ( event -> type == FocusIn || event -> type == FocusOut )
  {
    XFocusChangeEvent* ev = (XFocusChangeEvent*) event;
//  kdDebug() << "  Window " << ev -> window << " mode " << ev -> mode
//    << " detail " << ev -> detail << " sent " << ev -> send_event << "\n";
    if ( ev -> detail == NotifyAncestor && (event -> type == FocusIn && ev -> mode == NotifyUngrab
        || event -> type == FocusOut && ev -> mode == NotifyGrab) )
    {
      kdDebug() << "Calling KPlayerWidgetResizeHandler (" << (ev -> mode == NotifyGrab) << ")\n";
      KPlayerWidgetResizeHandler (ev -> mode == NotifyGrab);
    }
  }
/*else if ( event -> type == ConfigureNotify )
  {
    XConfigureEvent* ev = (XConfigureEvent*) event;
    kdDebug() << "  W " << ev -> window << " x " << ev -> x << " y " << ev -> y <<
      " w " << ev -> width << " h " << ev -> height << " b " << ev -> border_width <<
      " a " << ev -> above << " o " << ev -> override_redirect << " s " << ev -> send_event << "\n";
  }*/
  if ( PreviousX11EventFilter )
    return PreviousX11EventFilter (event);
  return 0;
}

extern QX11EventFilter qt_set_x11_event_filter (QX11EventFilter);

static int KPlayerX11EventFilterCount = 0;

void KPlayerSetX11EventFilter (void)
{
  if ( ! KPlayerX11EventFilterCount ++ )
    PreviousX11EventFilter = qt_set_x11_event_filter (KPlayerX11EventFilter);
}

void KPlayerResetX11EventFilter (void)
{
  if ( -- KPlayerX11EventFilterCount )
    return;
  qt_set_x11_event_filter (PreviousX11EventFilter);
  PreviousX11EventFilter = 0;
}
